Imports System.IO
Imports TurnVerein.TurnVereinDts

Public Class frmTurnVerein

   Private _DataFile As New FileInfo("..\..\TurnVereinDts.Xml")

   Public Sub New()
      InitializeComponent()
      TurnVereinDts.ReadXml(_DataFile.FullName)
   End Sub

   Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
      While Controls.Count > 0
         'there is a winforms-bug, that components get disposed first. This leads to exceptions, when ComboboxDatagridViewColumns Datasources become invalid. Workaround: Dispose controls first
         Controls(0).Dispose()
      End While
      TurnVereinDts.WriteXml(_DataFile.FullName)
   End Sub

   Private Sub btPersonsOfVeranstaltung_Click(sender As Object, e As EventArgs) Handles btPersonsOfVeranstaltung.Click
      Dim OutputLines As New List(Of String)()
      For Each rwVeranstaltung In TurnVereinDts.Veranstaltung
         OutputLines.Add(rwVeranstaltung.Name & ": ")
         For Each rwTurnVerein In rwVeranstaltung.GetTeilnahmeRows
            'indent Person-Names
            OutputLines.Add("     " & rwTurnVerein.PersonRow.Name)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines), "Persons of Veranstaltungs")
   End Sub

   Private Sub btVeranstaltungsOfPerson_Click(sender As Object, e As EventArgs) Handles btVeranstaltungsOfPerson.Click
      Dim OutputLines As New List(Of String)()
      For Each rwPerson As PersonRow In TurnVereinDts.Person
         OutputLines.Add(rwPerson.Name & ": ")
         For Each rwTurnVerein In rwPerson.GetTeilnahmeRows()
            'indent Veranstaltungs-Namees
            OutputLines.Add("     " & rwTurnVerein.VeranstaltungRow.Datum)
         Next
      Next
      MessageBox.Show(String.Join(Environment.NewLine, OutputLines), "Veranstaltungs of Persons")
   End Sub

   Private Sub btHideIds_Click(sender As Object, e As EventArgs) Handles btHideIds.Click
      StyleControls(tabPage2)
   End Sub

   Private Sub StyleControls(ctl As Control)
      For Each ctl In ctl.Controls
         Dim dgv = TryCast(ctl, DataGridView)
         If dgv IsNot Nothing Then
            For Each clm As DataGridViewColumn In dgv.Columns
               If TypeOf clm Is DataGridViewComboBoxColumn Then Continue For
               If clm.HeaderText.Contains("ID") Then
                  clm.Visible = Not btHideIds.Checked
               End If
            Next
         End If
         StyleControls(ctl)
      Next
   End Sub

End Class